
import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runners.Parameterized;


/*
Classe de test pour le déplacement du cavalier.
 */
public class TestDepC {
    @Parameterized.Parameter
    protected Cavalier cavalier;
    @Parameterized.Parameter
    protected Cavalier cavalier2;
    @Parameterized.Parameter
    protected Echiquier ech;

    @Before
    public void setUP(){
        cavalier = new Cavalier(Piece.BLANC);
        cavalier2 = new Cavalier(Piece.NOIR);
        ech = new Echiquier();
    }

    @After
    public void tearDown(){
    }

    @Test
    public void TestPlacement() throws Exception{
        ech.placer(cavalier, 0, 0);
        Assert.assertEquals(cavalier,ech.getPiece(0,0));
    }

    @Test
    public void TestDeplacement() throws Exception{
        ech.placer(cavalier,0,0);
        ech.deplacer(0,0,1,2);
        Assert.assertEquals(cavalier, ech.getPiece(1,2));
    }

    @Test
    public void TestPrise() throws Exception{
        ech.placer(cavalier, 0,0);
        ech.placer(cavalier2, 1,2);
        ech.deplacer(0,0,1,2);
        Assert.assertEquals(cavalier,ech.getPiece(1,2));
    }
}